## gensio 2.3.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

cmake_policy(SET CMP0078 NEW) # For swig

project(gensio VERSION 2.3.5)
set (gensio_VERSION_STRING "${gensio_VERSION_MAJOR}.${gensio_VERSION_MINOR}.${gensio_VERSION_PATCH}")

include_directories("${PROJECT_BINARY_DIR}" "${PROJECT_SOURCE_DIR}/include"
                    "${PROJECT_BINARY_DIR}/include" )

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(GNUInstallDirs)
include(FindPkgConfig)
include(FindTCL)

if (WIN32)
  # Suppress packing error warnings, as they are ubiquitous and don't matter.
  set (CMAKE_C_FLAGS "/wd4820")
  set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/output")
else()
  set (CMAKE_C_FLAGS "-Wall")
endif()
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(ALSOSTATIC "When buiding a shared library, build a static one, too")

option(ENABLE_TCP_WRAPPERS "Enable tcpwrappers support" ON)
if(ENABLE_TCP_WRAPPERS)
  CHECK_INCLUDE_FILE(tcpd.h HAVE_TCPD_H)
  if(HAVE_TCPD_H)
    list(APPEND EXTRA_LIBS wrap)
   endif()
endif()

option(ENABLE_PTHREADS "Enable pthreads" ON)
set(USE_PTHREADS 0)
if(ENABLE_PTHREADS)
  CHECK_LIBRARY_EXISTS(pthread "pthread_create" "" PTHREAD_LIB_FOUND)
  CHECK_INCLUDE_FILE(pthread.h PTHREAD_INC_FOUND)
  if(PTHREAD_LIB_FOUND AND PTHREAD_INC_FOUND)
    set(USE_PTHREADS 1)
    list(APPEND EXTRA_LIBS pthread)
  endif()
endif()

option(ENABLE_EPOLL "Enable epoll support" ON)
if(ENABLE_EPOLL)
  CHECK_INCLUDE_FILE(sys/epoll.h HAVE_EPOLL_PWAIT)
endif()

option(ENABLE_GLIB "Enable GLIB support" UNIX)
if(ENABLE_GLIB)
  pkg_check_modules(GLIB glib-2.0)
  if(GLIB_FOUND)
    set(HAVE_GLIB ON)
    set(GLIB_LIB gensioglib)
  endif()
endif()

set(TCL_LIBS )
option(ENABLE_TCL "Enable TCL support" UNIX)
if(ENABLE_TCL)
  if(TCL_FOUND)
    set(HAVE_TCL ON)
    set(TCL_LIB gensiotcl)
    set(TCL_LIBS ${TCL_LIBRARY})
  endif()
endif()

option(ENABLE_OPENIPMI "Enable OpenIPMI serial over LAN support" ON)
if(ENABLE_OPENIPMI)
  CHECK_LIBRARY_EXISTS(OpenIPMI "ipmi_alloc_os_handler" "" OPENIPMI_LIB_FOUND)
  CHECK_INCLUDE_FILE(OpenIPMI/ipmiif.h OPENIPMI_INC_FOUND)
  if(OPENIPMI_LIB_FOUND AND OPENIPMI_INC_FOUND)
    set(HAVE_OPENIPMI 1)
    if(USE_PTHREADS)
      list(APPEND EXTRA_LIBS OpenIPMI OpenIPMIpthread OpenIPMIutils)
    else()
      list(APPEND EXTRA_LIBS OpenIPMI OpenIPMIposix OpenIPMIutils)
    endif()
  endif()
endif()

option(ENABLE_OPENSSL "Enable openssl" ON)
set(HAVE_OPENSSL 0)
if(ENABLE_OPENSSL)
  CHECK_LIBRARY_EXISTS(ssl "SSL_connect" "" SSL_LIB_FOUND)
  CHECK_LIBRARY_EXISTS(crypto "X509_verify_cert" "" CRYPTO_LIB_FOUND)
  CHECK_INCLUDE_FILE(openssl/ssl.h SSL_INC_FOUND)
  CHECK_INCLUDE_FILE(openssl/x509.h CRYPTO_INC_FOUND)
  if(SSL_LIB_FOUND AND SSL_INC_FOUND AND CRYPTO_LIB_FOUND AND CRYPTO_INC_FOUND)
    set(HAVE_OPENSSL 1)
    list(APPEND EXTRA_LIBS ssl crypto)
  endif()
endif()

option(ENABLE_MDNS "Enable MDNS" ON)
set(HAVE_AVAHI 0)
if(ENABLE_MDNS)
  CHECK_LIBRARY_EXISTS(avahi-client "avahi_client_new" "" AVAHI_CLI_LIB_FOUND)
  CHECK_LIBRARY_EXISTS(avahi-common "avahi_malloc" "" AVAHI_COM_LIB_FOUND)
  CHECK_INCLUDE_FILE(avahi-client/client.h AVAHI_CLI_INC_FOUND)
  CHECK_INCLUDE_FILE(avahi-common/malloc.h AVAHI_COM_INC_FOUND)
  if(AVAHI_CLI_LIB_FOUND AND AVAHI_CLI_INC_FOUND AND AVAHI_COM_LIB_FOUND AND AVAHI_COM_INC_FOUND)
    set(HAVE_AVAHI 1)
    list(APPEND EXTRA_LIBS avahi-client avahi-common)
  endif()
endif()

option(ENABLE_SWIG "Enable swig support" ON)
if(ENABLE_SWIG)
  find_package(SWIG)
endif()

option(ENABLE_PYTHON "Enable python support" ON)
if(ENABLE_PYTHON)
  set (Python_ADDITIONAL_VERSIONS 3 2)
  find_package(PythonInterp)
  find_package(PythonLibs)
  # FIXME - we are assuming this for now.
  option(PYTHON_HAS_THREADS "Support threading in python" ON)
endif()

option(ENABLE_SCTP "Enable SCTP support" ON)
if(ENABLE_SCTP)
  CHECK_LIBRARY_EXISTS(sctp "sctp_bindx" "" HAVE_LIBSCTP)
  if (HAVE_LIBSCTP)
    list(APPEND EXTRA_LIBS sctp)
  endif()
endif()
if(HAVE_LIBSCTP)
  CHECK_LIBRARY_EXISTS(sctp "sctp_sendv" "" HAVE_SCTP_SENDV)
endif()

string(COMPARE EQUAL "${CMAKE_HOST_SYSTEM_NAME}" "Linux" HAVE_WORKING_PORT0)

CHECK_LIBRARY_EXISTS(pam "pam_start" "" HAVE_PAM)

check_symbol_exists(TIOCSRS485 sys/ioctl.h HAVE_DECL_TIOCSRS485)

CHECK_INCLUDE_FILE(sys/un.h HAVE_UNIX)

option(USE_FILE_STDIO "Use stdio instead of unix files for the file gensio"
       ${MSVC})

option(ENABLE_INTERNAL_TRACE
       "Enable internal trace tools, required for oomtest"
       OFF)

set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set (includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set (VERSION "${PROJECT_VERSION}")

check_c_source_compiles("int main()
{
	static int counter = 0;
	int val;

	__atomic_load(&counter, &val, __ATOMIC_SEQ_CST);
	return val;
}" HAVE_GCC_ATOMICS)

check_symbol_exists(sendmsg sys/socket.h HAVE_SENDMSG)
check_symbol_exists(isatty unistd.h HAVE_ISATTY)
check_symbol_exists(strcasecmp string.h HAVE_STRCASECMP)
check_symbol_exists(strncasecmp string.h HAVE_STRNCASECMP)
check_symbol_exists(prctl sys/prctl.h HAVE_PRCTL)
check_symbol_exists(getrandom sys/random.h HAVE_GETRANDOM_FUNC)
set (CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE")
check_symbol_exists(ptsname_r "stdlib.h" HAVE_PTSNAME_R)
check_symbol_exists(cfmakeraw "termios.h" HAVE_CFMAKERAW)
check_symbol_exists(signalfd "signalfd.h" HAVE_SIGNALFD)
check_symbol_exists(regexec "regex.h" HAVE_REGEXEC)
check_symbol_exists(fnmatch "fnmatch.h" HAVE_FNMATCH)

if (${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
  set(APPLE ON)
else()
  set(APPLE OFF)
endif()

if (${UNIX})
  if (${APPLE})
    set(DEF_UUCP_LOCKING OFF)
  else()
    set(DEF_UUCP_LOCKING ON)
  endif()
else()
  set(DEF_UUCP_LOCKING OFF)
endif()
if (${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Linux")
  set(UUCP_LOCK_DIR "/var/lock")
else()
  set(UUCP_LOCK_DIR "/var/spool/lock")
endif()
option(USE_UUCP_LOCKING "Enable UUCP lock file handling for devices"
       ${DEF_UUCP_LOCKING})

if(UNIX)
  set(HAVE_PTY 1)
else()
  set(HAVE_PTY 0)
  list(APPEND EXTRA_LIBS ws2_32 bcrypt)
endif()

configure_file(config.h.cmake config.h)

add_subdirectory(lib)
add_subdirectory(c++)
if(HAVE_GLIB)
  add_subdirectory(glib)
endif()
if(HAVE_TCL)
  add_subdirectory(tcl)
endif()
add_subdirectory(include)
add_subdirectory(tools)
add_subdirectory(examples)
if(SWIG_FOUND)
  add_subdirectory(swig)
endif()
add_subdirectory(man)
add_subdirectory(tests)

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${gensio_VERSION_MAJOR}.${gensio_VERSION_MINOR}.${gensio_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES "/.git/;/Z.*/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== c++/CMakeLists.txt ===

add_subdirectory(include)
add_subdirectory(lib)
add_subdirectory(tests)
add_subdirectory(examples)

=== glib/CMakeLists.txt ===

set(LIBFILES gensio_glib.c)

add_library(gensioglib ${LIBFILES})
if(BUILD_SHARED_LIBS AND ALSOSTATIC)
  add_library(gensioglib-static STATIC ${LIBFILES})
  SET_TARGET_PROPERTIES(gensioglib-static PROPERTIES OUTPUT_NAME gensioglib
                        CLEAN_DIRECT_OUTPUT 1)
  install(TARGETS gensioglib-static DESTINATION lib)
endif()
target_link_libraries(gensioglib ${EXTRA_LIBS})
set_property(TARGET gensioglib PROPERTY VERSION 0.0.0)
set_property(TARGET gensioglib PROPERTY SOVERSION 0)

install(TARGETS gensioglib DESTINATION lib EXPORT gensioglib)
install(EXPORT gensioglib FILE gensioglib.cmake DESTINATION lib/cmake/gensio)
set_target_properties(gensioglib PROPERTIES COMPILE_FLAGS
                      "-DBUILDING_GENSIO_DLL")
if (WIN32)
  # Stick this in the directories so Windows can find it when running
  # gensiot and oomtest.  Probably not right, but works for now.
  install(TARGETS gensio DESTINATION bin)
endif()
target_include_directories(gensioglib
                           INTERFACE
                            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                            $<INSTALL_INTERFACE:include>
                           )
target_include_directories(gensioglib PUBLIC ${GLIB_INCLUDE_DIRS})
include_directories("include")

if(SWIG_FOUND)
  add_subdirectory(swig)
endif()

configure_file(libgensioglib.pc.in libgensioglib.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgensioglib.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

install(FILES gensio_glib_funcs_alloc.3 DESTINATION
        ${CMAKE_INSTALL_FULL_MANDIR}/man8)

=== lib/CMakeLists.txt ===
set(BASE_LIBFILES
  buffer.c
  gensio_net.c
  gensio_filter_telnet.c
  gensio_ssl.c
  gensio_acc.c
  gensio_filter_trace.c
  gensio_acc_gensio.c
  gensio_trace.c
  gensio_base.c
  gensio_ll_gensio.c
  gensio_ll_fd.c
  gensio_udp.c
  gensio.c
  gensio_ll_ipmisol.c
  gensio_certauth.c
  gensio_msgdelim.c
  sergensio.c
  gensio_dummy.c
  gensio_mux.c
  sergensio_ipmisol.c
  gensio_echo.c
  gensio_file.c
  sergensio_telnet.c
  gensio_filter_certauth.c
  telnet.c
  gensio_filter_msgdelim.c
  gensio_relpkt.c
  utils.c
  gensio_filter_relpkt.c
  gensio_sctp.c
  gensio_filter_ssl.c
  gensio_perf.c
  gensio_filter_perf.c
  gensio_conacc.c
  errtrig.c
  mdns.c
  avahi_watcher.c
  gensio_mdns.c
  gensio_stdio.c
  sergensio_serialdev.c
  gensio_circbuf.c
  gensio_addrinfo.c
  gensio_stdsock.c
  uucplock.c
  gensio_pty.c
  gensio_osops.c
  gensio_osops_env.c)

set(UNIX_LIBFILES
  selector.c
  gensio_unix.c)

set(WINDOWS_LIBFILES
  gensio_win.c)

if(UNIX)
  set(LIBFILES ${BASE_LIBFILES} ${UNIX_LIBFILES})
else()
  set(LIBFILES ${BASE_LIBFILES} ${WINDOWS_LIBFILES})
endif()

add_library(gensio ${LIBFILES})
if(BUILD_SHARED_LIBS AND ALSOSTATIC)
  add_library(gensio-static STATIC ${LIBFILES})
  SET_TARGET_PROPERTIES(gensio-static PROPERTIES OUTPUT_NAME gensio
                        CLEAN_DIRECT_OUTPUT 1)
  install(TARGETS gensio-static DESTINATION lib)
endif()
target_link_libraries(gensio ${EXTRA_LIBS})
set_property(TARGET gensio PROPERTY VERSION 0.0.0)
set_property(TARGET gensio PROPERTY SOVERSION 0)

install(TARGETS gensio DESTINATION lib EXPORT gensio)
install(EXPORT gensio FILE gensio.cmake DESTINATION lib/cmake/gensio)
set_target_properties(gensio PROPERTIES COMPILE_FLAGS "-DBUILDING_GENSIO_DLL")
if (WIN32)
  # Stick this in the directories so Windows can find it when running
  # gensiot and oomtest.  Probably not right, but works for now.
  install(TARGETS gensio DESTINATION bin)
endif()
target_include_directories(gensio
                           INTERFACE
                            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                            $<INSTALL_INTERFACE:include>
                           )

configure_file(libgensio.pc.in libgensio.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgensio.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== man/CMakeLists.txt ===

install(FILES gensio.5 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5)

install(FILES gensio_event.3 str_to_gensio.3 gensio_set_callback.3
	gensio_set_log_mask.3 gensio_os_funcs.3 gensio_err.3 gensio_write.3
	gensio_open.3 gensio_alloc_channel.3 gensio_close.3 gensio_control.3
	gensio_set_read_callback_enable.3 gensio_get_type.3 gensio_set_sync.3
	gensio_accepter_event.3 gensio_acc_set_callback.3
	gensio_acc_shutdown.3 gensio_acc_set_accept_callback_enable.3
	gensio_acc_control.3 gensio_acc_get_type.3 gensio_add_default.3
	str_to_gensio_accepter.3 gensio_acc_accept_s.3 gensio_acc_startup.3
	gensio_mdns.3 sergensio.5 gensio_to_sergensio.3 sergensio_baud.3
	sergensio_b_alloc.3 sergensio_event.3 gensio_mdns.3
	DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man3)

macro(install_man3_symlink filepath sympath)
    install(CODE "execute_process(COMMAND sh -c \"${CMAKE_COMMAND} -E create_symlink ${filepath} $DESTDIR${CMAKE_INSTALL_FULL_MANDIR}/man3/${sympath}\")")
    install(CODE "message(\"-- Created symlink: ${sympath} -> ${filepath}\")")
endmacro(install_man3_symlink)

install_man3_symlink(str_to_gensio.3 str_to_gensio_child.3)
install_man3_symlink(str_to_gensio.3 gensio_acc_str_to_gensio.3)
install_man3_symlink(gensio_set_callback.3 gensio_set_user_data.3)
install_man3_symlink(gensio_set_callback.3 gensio_get_user_data.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_get_log_mask.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_log_level_to_str.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_vlog.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_log.3)
install_man3_symlink(gensio_os_funcs.3 gensio_default_os_hnd.3)
install_man3_symlink(gensio_os_funcs.3 gensio_unix_funcs_alloc.3)
install_man3_symlink(gensio_os_funcs.3 gensio_win_funcs_alloc.3)
install_man3_symlink(gensio_os_funcs.3 gensio_os_proc_setup.3)
install_man3_symlink(gensio_os_funcs.3 gensio_os_proc_cleanup.3)
install_man3_symlink(gensio_os_funcs.3 gensio_os_proc_unix_get_wait_sigset.3)
install_man3_symlink(gensio_os_funcs.3 gensio_os_new_thread.3)
install_man3_symlink(gensio_os_funcs.3 gensio_os_wait_thread.3)
install_man3_symlink(gensio_err.3 gensio_err_to_str.3)
install_man3_symlink(gensio_write.3 gensio_write_sg.3)
install_man3_symlink(gensio_open.3 gensio_open_s.3)
install_man3_symlink(gensio_open.3 gensio_open_nochild.3)
install_man3_symlink(gensio_open.3 gensio_open_nochild_s.3)
install_man3_symlink(gensio_close.3 gensio_close_s.3)
install_man3_symlink(gensio_close.3 gensio_disable.3)
install_man3_symlink(gensio_close.3 gensio_free.3)
install_man3_symlink(gensio_set_read_callback_enable.3
		     gensio_set_write_callback_enable.3)
install_man3_symlink(gensio_get_type.3 gensio_get_child.3)
install_man3_symlink(gensio_get_type.3 gensio_is_client.3)
install_man3_symlink(gensio_get_type.3 gensio_is_reliable.3)
install_man3_symlink(gensio_get_type.3 gensio_is_packet.3)
install_man3_symlink(gensio_get_type.3 gensio_is_message.3)
install_man3_symlink(gensio_get_type.3 gensio_is_authenticated.3)
install_man3_symlink(gensio_get_type.3 gensio_is_encrypted.3)
install_man3_symlink(gensio_set_sync.3 gensio_clear_sync.3)
install_man3_symlink(gensio_set_sync.3 gensio_read_s.3)
install_man3_symlink(gensio_set_sync.3 gensio_write_s.3)
install_man3_symlink(str_to_gensio_accepter.3 str_to_gensio_accepter_child.3)
install_man3_symlink(gensio_acc_set_callback.3 gensio_acc_set_user_data.3)
install_man3_symlink(gensio_acc_set_callback.3 gensio_acc_get_user_data.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_shutdown_s.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_disable.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_free.3)
install_man3_symlink(gensio_acc_set_accept_callback_enable.3
		     gensio_acc_set_accept_callback_enable_cb.3)
install_man3_symlink(gensio_acc_set_accept_callback_enable.3
		     gensio_acc_set_accept_callback_enable_s.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_reliable.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_packet.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_message.3)
install_man3_symlink(gensio_add_default.3 gensio_set_default.3)
install_man3_symlink(gensio_add_default.3 gensio_get_default.3)
install_man3_symlink(gensio_add_default.3 gensio_get_defaultaddr.3)
install_man3_symlink(gensio_add_default.3 gensio_del_default.3)
install_man3_symlink(gensio_add_default.3 gensio_reset_defaults.3)
install_man3_symlink(gensio_acc_accept_s.3 gensio_acc_set_sync.3)
install_man3_symlink(gensio_mdns.3 gensio_alloc_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_free_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_watch.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_watch.3)
install_man3_symlink(gensio_to_sergensio.3 sergensio_to_gensio.3)
install_man3_symlink(gensio_to_sergensio.3 sergensio_get_user_data.3)
install_man3_symlink(gensio_to_sergensio.3 sergensio_is_client.3)
install_man3_symlink(sergensio_baud.3 sergensio_datasize.3)
install_man3_symlink(sergensio_baud.3 sergensio_parity.3)
install_man3_symlink(sergensio_baud.3 sergensio_stopbits.3)
install_man3_symlink(sergensio_baud.3 sergensio_flowcontrol.3)
install_man3_symlink(sergensio_baud.3 sergensio_iflowcontrol.3)
install_man3_symlink(sergensio_baud.3 sergensio_sbreak.3)
install_man3_symlink(sergensio_baud.3 sergensio_dtr.3)
install_man3_symlink(sergensio_baud.3 sergensio_rts.3)
install_man3_symlink(sergensio_baud.3 sergensio_signature.3)
install_man3_symlink(sergensio_baud.3 sergensio_linestate.3)
install_man3_symlink(sergensio_baud.3 sergensio_modemstate.3)
install_man3_symlink(sergensio_baud.3 sergensio_flowcontrol_state.3)
install_man3_symlink(sergensio_baud.3 sergensio_flush.3)
install_man3_symlink(sergensio_baud.3 sergensio_send_break.3)
install_man3_symlink(sergensio_baud.3 sergensio_cts.3)
install_man3_symlink(sergensio_baud.3 sergensio_dcd_dsr.3)
install_man3_symlink(sergensio_baud.3 sergensio_ri.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_b_free.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_baud_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_datasize_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_parity_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_stopbits_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_flowcontrol_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_iflowcontrol_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_sbreak_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_dtr_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_rts_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_cts_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_dcd_dsr_b.3)
install_man3_symlink(sergensio_b_alloc.3 sergensio_ri_b.3)
install_man3_symlink(gensio_mdns.3 gensio_alloc_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_free_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_watch.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_watch.3)

=== tcl/CMakeLists.txt ===

set(LIBFILES gensio_tcl.c)

add_library(gensiotcl ${LIBFILES})
if(BUILD_SHARED_LIBS AND ALSOSTATIC)
  add_library(gensiotcl-static STATIC ${LIBFILES})
  SET_TARGET_PROPERTIES(gensiotcl-static PROPERTIES OUTPUT_NAME gensiotcl
                        CLEAN_DIRECT_OUTPUT 1)
  install(TARGETS gensiotcl-static DESTINATION lib)
endif()
target_link_libraries(gensiotcl ${TCL_LIBRARY})
set_property(TARGET gensiotcl PROPERTY VERSION 0.0.0)
set_property(TARGET gensiotcl PROPERTY SOVERSION 0)

install(TARGETS gensiotcl DESTINATION lib EXPORT gensiotcl)
install(EXPORT gensiotcl FILE gensiotcl.cmake DESTINATION lib/cmake/gensio)
set_target_properties(gensiotcl PROPERTIES COMPILE_FLAGS
                      "-DBUILDING_GENSIO_DLL")
if (WIN32)
  # Stick this in the directories so Windows can find it when running
  # gensiot and oomtest.  Probably not right, but works for now.
  install(TARGETS gensio DESTINATION bin)
endif()
target_include_directories(gensiotcl
                           INTERFACE
                            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                            $<INSTALL_INTERFACE:include>
                           )
target_include_directories(gensiotcl PUBLIC ${TCL_INCLUDE_PATH})
include_directories("include")

if(SWIG_FOUND)
  add_subdirectory(swig)
endif()

configure_file(libgensiotcl.pc.in libgensiotcl.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgensiotcl.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

install(FILES gensio_tcl_funcs_alloc.3 DESTINATION
        ${CMAKE_INSTALL_FULL_MANDIR}/man8)

=== tests/CMakeLists.txt ===

enable_testing()

add_executable(oomtest oomtest.c)
target_link_libraries(oomtest gensio ${GLIB_LIB} ${GLIB_LDFLAGS}
                      ${TCL_LIB} ${TCL_LIBS})

include_directories("${PROJECT_SOURCE_DIR}/glib/include"
		    "${PROJECT_SOURCE_DIR}/tcl/include")

set (top_srcdir "${CMAKE_SOURCE_DIR}")
set (top_builddir "${CMAKE_BINARY_DIR}")
configure_file(runtest.in runtest @ONLY)
configure_file(gensios_enabled.py.in gensios_enabled.py @ONLY)

add_test(NAME syncio
         COMMAND runtest test_syncio.py)
set_tests_properties(syncio PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME echo
         COMMAND runtest test_echo_gensio.py)
set_tests_properties(echo PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME echo_device
         COMMAND runtest test_echo_device.py)
set_tests_properties(echo_device PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME serial_pipe_device
         COMMAND runtest test_serial_pipe_device.py)
set_tests_properties(serial_pipe_device PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_tcp
         COMMAND runtest test_accept_tcp.py)
set_tests_properties(accept_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_udp
         COMMAND runtest test_accept_udp.py)
set_tests_properties(accept_udp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_sctp
         COMMAND runtest test_accept_sctp.py)
set_tests_properties(accept_sctp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_ssl_tcp
         COMMAND runtest test_accept_ssl_tcp.py)
set_tests_properties(accept_ssl_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_certauth_tcp
         COMMAND runtest test_accept_certauth_tcp.py)
set_tests_properties(accept_certauth_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_mux_sctp
         COMMAND runtest test_accept_mux_sctp.py)
set_tests_properties(accept_mux_sctp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet
         COMMAND runtest test_telnet.py)
set_tests_properties(telnet PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME modemstate
         COMMAND runtest test_modemstate.py)
set_tests_properties(modemstate PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio
         COMMAND runtest test_stdio_basic.py)
set_tests_properties(stdio PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio_stderr
         COMMAND runtest test_stdio_basic_stderr.py)
set_tests_properties(stdio_stderr PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio_small
         COMMAND runtest test_stdio_small.py)
set_tests_properties(stdio_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_small
         COMMAND runtest test_tcp_small.py)
set_tests_properties(tcp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_urgent
         COMMAND runtest test_tcp_urgent.py)
set_tests_properties(tcp_urgent PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME pty
         COMMAND runtest test_pty_basic.py)
set_tests_properties(pty PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_small
         COMMAND runtest test_sctp_small.py)
set_tests_properties(sctp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_streams
         COMMAND runtest test_sctp_streams.py)
set_tests_properties(sctp_streams PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_oob
         COMMAND runtest test_sctp_oob.py)
set_tests_properties(sctp_oob PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet_small
         COMMAND runtest test_telnet_small.py)
set_tests_properties(telnet_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ipmisol_small
         COMMAND runtest test_ipmisol_small.py)
set_tests_properties(ipmisol_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ipmisol_large
         COMMAND runtest test_ipmisol_large.py)
set_tests_properties(ipmisol_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME rs485
         COMMAND runtest test_rs485.py)
set_tests_properties(rs485 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_accept_connect
         COMMAND runtest test_tcp_accept_connect.py)
set_tests_properties(tcp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME unix_accept_connect
         COMMAND runtest test_unix_accept_connect.py)
set_tests_properties(unix_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME udp_accept_connect
         COMMAND runtest test_udp_accept_connect.py)
set_tests_properties(udp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_accept_connect
         COMMAND runtest test_sctp_accept_connect.py)
set_tests_properties(sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet_sctp_accept_connect
         COMMAND runtest test_telnet_sctp_accept_connect.py)
set_tests_properties(telnet_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ssl_sctp_accept_connect
         COMMAND runtest test_ssl_sctp_accept_connect.py)
set_tests_properties(ssl_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME certauth_sctp_accept_connect
         COMMAND runtest test_certauth_sctp_accept_connect.py)
set_tests_properties(certauth_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME certauth_ssl_tcp_accept_connect
         COMMAND runtest test_certauth_ssl_tcp_accept_connect.py)
set_tests_properties(certauth_ssl_tcp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_sctp_small
         COMMAND runtest test_mux_sctp_small.py)
set_tests_properties(mux_sctp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_tcp_large
         COMMAND runtest test_mux_tcp_large.py)
set_tests_properties(mux_tcp_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_limits
         COMMAND runtest test_mux_limits.py)
set_tests_properties(mux_limits PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_oob
         COMMAND runtest test_mux_oob.py)
set_tests_properties(mux_oob PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt
         COMMAND runtest test_relpkt_basic.py)
set_tests_properties(relpkt PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_small
         COMMAND runtest test_relpkt_small.py)
set_tests_properties(relpkt_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_medium
         COMMAND runtest test_relpkt_medium.py)
set_tests_properties(relpkt_medium PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_large
         COMMAND runtest test_relpkt_large.py)
set_tests_properties(relpkt_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_udp_nocon
         COMMAND runtest test_udp_nocon.py)
 set_tests_properties(test_udp_nocon PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_perf
         COMMAND runtest test_perf.py)
set_tests_properties(test_perf PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_trace
         COMMAND runtest test_trace.py)
set_tests_properties(test_trace PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_file
         COMMAND runtest test_file.py)
set_tests_properties(test_file PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_dummy
         COMMAND runtest test_dummy.py)
set_tests_properties(test_dummy PROPERTIES SKIP_RETURN_CODE 77)

add_test(NAME oomtest0
         COMMAND runtest oomtest -t 0 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest0 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest1
         COMMAND runtest oomtest -t 1 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest1 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest2
         COMMAND runtest oomtest -t 2 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest2 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest3
         COMMAND runtest oomtest -t 3 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest3 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest4
         COMMAND runtest oomtest -t 4 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest4 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest5
         COMMAND runtest oomtest -t 5 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest5 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest6
         COMMAND runtest oomtest -t 6 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest6 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest7
         COMMAND runtest oomtest -t 7 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest7 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest8
         COMMAND runtest oomtest -t 8 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest8 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest9
         COMMAND runtest oomtest -t 9 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest9 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest10
         COMMAND runtest oomtest -t 10 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest10 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest11
         COMMAND runtest oomtest -t 11 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest11 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest12
         COMMAND runtest oomtest -t 12 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest12 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest13
         COMMAND runtest oomtest -t 13 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest13 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest14
         COMMAND runtest oomtest -t 14 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest14 PROPERTIES SKIP_RETURN_CODE 77)

#
# If you get certauth fuzz failures, they will be in the
# fuzz-results-certauth/crashes or fuzz-results-certauth/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand certauth-randfile -i echo 'certauth(CA=ca/clientcert.pem,allow-unencrypted,mode=server),file(infile="fuzz-results-certauth/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_certauth
   COMMAND rm -rf fuzz-test-certauth fuzz-results-certauth
   COMMAND mkdir -p fuzz-test-certauth
   COMMAND mkdir -p fuzz-results-certauth
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot certauth-randfile
		"'certauth(cert=ca/clientcert.pem,key=ca/clientkey.pem,allow-unencrypted)'"
		"'certauth(CA=ca/clientcert.pem,allow-unencrypted)'"
		fuzz-test-certauth/tracefile
   COMMAND afl-fuzz -i fuzz-test-certauth -o fuzz-results-certauth
		-f certauth-infile
		${PROJECT_BINARY_DIR}/tools/gensiot --dummyrand certauth-randfile
		-i echo
		"'certauth(CA=ca/clientcert.pem,allow-unencrypted,mode=server),file(infile=certauth-infile)'"
)

#
# If you get mux fuzz failures, they will be in the
# fuzz-results-mux/crashes or fuzz-results-mux/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand mux-randfile -i echo 'mux(writebuf=10000,mode=server),file(infile="fuzz-results-mux/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_mux
   COMMAND rm -rf fuzz-test-mux fuzz-results-mux
   COMMAND mkdir -p fuzz-test-mux
   COMMAND mkdir -p fuzz-results-mux
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot mux-randfile
		"mux" "mux"
		fuzz-test-mux/tracefile
   COMMAND afl-fuzz -i fuzz-test-mux -o fuzz-results-mux
		-f mux-infile
		${PROJECT_BINARY_DIR}/tools/gensiot --dummyrand mux-randfile
		-i echo
		"'mux,file(infile=mux-infile)'"
)

#
# If you get ssl fuzz failures, they will be in the
# fuzz-results-ssl/crashes or fuzz-results-ssl/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand ssl-randfile -i echo 'ssl(key=ca/key.pem,cert=ca/cert.pem,mode=server),file(infile="fuzz-results-ssl/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_ssl
   COMMAND rm -rf fuzz-test-ssl fuzz-results-ssl
   COMMAND mkdir -p fuzz-test-ssl
   COMMAND mkdir -p fuzz-results-ssl
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot ssl-randfile
		"'ssl(CA=ca/CA.pem)'"

=== c++/examples/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/c++/include")

add_executable(telnet_server telnet_server.cc)
target_link_libraries(telnet_server gensio gensiocpp)

=== c++/include/CMakeLists.txt ===
add_subdirectory(gensio)

=== c++/lib/CMakeLists.txt ===

include_directories("${PROJECT_SOURCE_DIR}/c++/include")

set(CPPLIBFILES gensio.cc)

add_library(gensiocpp ${CPPLIBFILES})
target_link_libraries(gensiocpp gensio)
set_target_properties(gensiocpp PROPERTIES COMPILE_FLAGS "-DBUILDING_GENSIOCPP_DLL")
if(BUILD_SHARED_LIBS AND ALSOSTATIC)
  add_library(gensiocpp-static STATIC ${CPPLIBFILES})
  SET_TARGET_PROPERTIES(gensiocpp-static PROPERTIES OUTPUT_NAME gensiocpp
                        CLEAN_DIRECT_OUTPUT 1)
  install(TARGETS gensiocpp-static DESTINATION lib)
endif()
set_property(TARGET gensiocpp PROPERTY VERSION 0.0.0)
set_property(TARGET gensiocpp PROPERTY SOVERSION 0)
install(TARGETS gensiocpp DESTINATION lib EXPORT gensiocpp)
configure_file(libgensiocpp.pc.in libgensiocpp.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgensiocpp.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== c++/tests/CMakeLists.txt ===

enable_testing()

include_directories("${PROJECT_SOURCE_DIR}/c++/include")

add_executable(basic_cpp_test basic_cpp_test.cc)
target_link_libraries(basic_cpp_test gensio gensiocpp)

add_executable(serial_test serial_test.cc)
target_link_libraries(serial_test gensio gensiocpp)

add_test(NAME basic_cpp_test
         COMMAND basic_cpp_test)
set_tests_properties(basic_cpp_test PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME serial_test
         COMMAND serial_test)
set_tests_properties(serial_test PROPERTIES SKIP_RETURN_CODE 77)

=== glib/swig/CMakeLists.txt ===
include(UseSWIG)
if(PYTHONLIBS_FOUND)
  add_subdirectory(python)
endif()

=== debian/changelog ===
gensio (2.3.5-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:17:21 +0000

gensio (2.3.5-1build1) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 23:31:40 +0000

gensio (2.3.5-1) unstable; urgency=medium

  * new upstream version 2.3.5

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sat, 06 Feb 2021 12:00:53 +0100

=== debian/control ===
Source: gensio
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Marc Haber <mh+debian-packages@zugschlus.de>
Build-Depends: debhelper-compat (= 13), dh-python, swig, python3-dev,
 pkg-config, libssl-dev, libwrap0-dev, libopenipmi-dev (>= 2.0.27),
 libpam-dev, libsctp-dev, libavahi-client-dev
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/cminyard/gensio
Vcs-Browser: https://salsa.debian.org/debian/gensio
Vcs-Git: https://salsa.debian.org/debian/gensio.git
Rules-Requires-Root: no

Package: libgensio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgensio0 (= ${binary:Version}), ${misc:Depends}
Description: abstract stream I/O (development files)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the development headers and static libraries.

Package: libgensio0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: abstract stream I/O (runtime files)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the shared libraries.

Package: python3-gensio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${python3:Provides}
Description: abstract stream I/O (python 3 bindings)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the python 3 bindings.

Package: gensio-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: abstract stream I/O (command line tool)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the command line tool.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with python3,autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-tcp-wrappers \
		--with-openssl \
		--with-avahi \
		--with-swig \
		--with-python

override_dh_auto_clean:
	dh_auto_clean
	rm -rf tests/__pycache__

# disable the upstream tests, they depend on an out-of-tree kernel module
override_dh_auto_test:
	true
